#include "angband.h"
#include "cmd-spell.h"

/*!
* @brief ̈斂@̊es
* @param spell @ID
* @param mode e (SPELL_NAME / SPELL_DESC / SPELL_INFO / SPELL_CAST)
* @return SPELL_NAME / SPELL_DESC / SPELL_INFO ɂ͕|C^ԂBSPELL_CASTNULLԂB
*/
cptr do_life_spell(SPELL_IDX spell, BIT_FLAGS mode)
{
	bool name = (mode == SPELL_NAME) ? TRUE : FALSE;
	bool desc = (mode == SPELL_DESC) ? TRUE : FALSE;
	bool info = (mode == SPELL_INFO) ? TRUE : FALSE;
	bool cast = (mode == SPELL_CAST) ? TRUE : FALSE;

	int dir;
	int plev = p_ptr->lev;

	switch (spell)
	{
	case 0:
		if (name) return _("y̎", "Cure Light Wounds");
		if (desc) return _("Ƒ̗͂񕜂B", "Heals cut and HP a little.");
		{
			int dice = 2;
			int sides = 10;
			if (info) return info_heal(dice, sides, 0);
			if (cast) (void)cure_light_wounds(dice, sides);			
		}
		break;

	case 1:
		if (name) return _("j", "Bless");
		if (desc) return _("莞ԁAACɃ{[iX𓾂B", "Gives bonus to hit and AC for a few turns.");
		{
			int base = 12;

			if (info) return info_duration(base, base);

			if (cast)
			{
				set_blessed(randint1(base) + base, FALSE);
			}
		}
		break;

	case 2:
		if (name) return _("y", "Cause Light Wounds");
		if (desc) return _("1̂̃X^[ɏ_[W^BRƖB", "Wounds a monster a little unless resisted.");
		{
			int dice = 3 + (plev - 1) / 5;
			int sides = 4;

			if (info) return info_damage(dice, sides, 0);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;
				fire_ball_hide(GF_WOUNDS, dir, damroll(dice, sides), 0);
			}
		}
		break;

	case 3:
		if (name) return _("̏", "Call Light");
		if (desc) return _("Ƃ炵Ă͈͂Ŝivɖ邭B", "Lights up nearby area and the inside of a room permanently.");
		{
			int dice = 2;
			int sides = plev / 2;
			int rad = plev / 10 + 1;

			if (info) return info_damage(dice, sides, 0);

			if (cast)
			{
				lite_area(damroll(dice, sides), rad);
			}
		}
		break;

	case 4:
		if (name) return _(" & Bm", "Detect Doors & Traps");
		if (desc) return _("߂̑SĂ㩂ƔƊKimB", "Detects traps, doors, and stairs in your vicinity.");
		{
			int rad = DETECT_RAD_DEFAULT;

			if (info) return info_radius(rad);

			if (cast)
			{
				detect_traps(rad, TRUE);
				detect_doors(rad);
				detect_stairs(rad);
			}
		}
		break;

	case 5:
		if (name) return _("d̎", "Cure Medium Wounds");
		if (desc) return _("Ƒ̗͂𒆒x񕜂B", "Heals cut and HP more.");
		{
			int dice = 4;
			int sides = 10;

			if (info) return info_heal(dice, sides, 0);
			if (cast) (void)cure_serious_wounds(dice, sides);
		}
		break;

	case 6:
		if (name) return _("", "Cure Poison");
		if (desc) return _("̓̓ł菜B", "Cure poison status.");
		{
			if (cast)
			{
				set_poisoned(0);
			}
		}
		break;

	case 7:
		if (name) return _("󕠏[", "Satisfy Hunger");
		if (desc) return _("ɂB", "Satisfies hunger.");
		{
			if (cast)
			{
				set_food(PY_FOOD_MAX - 1);
			}
		}
		break;

	case 8:
		if (name) return _("", "Remove Curse");
		if (desc) return _("ACeɂア􂢂B", "Removes normal curses from equipped items.");
		{
			if (cast)
			{
				if (remove_curse())
				{
					msg_print(_("NɌĂ悤ȋCB", "You feel as if someone is watching over you."));
				}
			}
		}
		break;

	case 9:
		if (name) return _("d", "Cause Medium Wounds");
		if (desc) return _("1̂̃X^[ɒ_[W^BRƖB", "Wounds a monster unless resisted.");
		{
			int sides = 8 + (plev - 5) / 4;
			int dice = 8;

			if (info) return info_damage(dice, sides, 0);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;
				fire_ball_hide(GF_WOUNDS, dir, damroll(dice, sides), 0);
			}
		}
		break;

	case 10:
		if (name) return _("v̎", "Cure Critical Wounds");
		if (desc) return _("̗͂啝ɉ񕜂AƞNOԂSB", "Heals cut, stun and HP greatly.");
		{
			int dice = 8;
			int sides = 10;

			if (info) return info_heal(dice, sides, 0);
			if (cast) (void)cure_critical_wounds(damroll(dice, sides));
		}
		break;

	case 11:
		if (name) return _("ϔMϊ", "Resist Heat and Cold");
		if (desc) return _("莞ԁAΉƗCɑ΂ϐ𓾂BɂϐɗݐςB",
			"Gives resistance to fire and cold. These resistances can be added to which from equipment for more powerful resistances.");

		{
			int base = 20;

			if (info) return info_duration(base, base);

			if (cast)
			{
				set_oppose_cold(randint1(base) + base, FALSE);
				set_oppose_fire(randint1(base) + base, FALSE);
			}
		}
		break;

	case 12:
		if (name) return _("ӊm", "Sense Surroundings");
		if (desc) return _("ӂ̒n`mB", "Maps nearby area.");

		{
			int rad = DETECT_RAD_MAP;

			if (info) return info_radius(rad);

			if (cast)
			{
				map_area(rad);
			}
		}
		break;

	case 13:
		if (name) return _("pjbNEAfbh", "Turn Undead");
		if (desc) return _("ẼAfbh|BRƖB", "Attempts to scare undead monsters in sight.");

		{
			if (cast)
			{
				turn_undead();
			}
		}
		break;

	case 14:
		if (name) return _("̗͉", "Healing");
		if (desc) return _("ɂ߂ċ͂ȉ񕜎ŁAƞNOԂSB", "Much powerful healing magic, and heals cut and stun completely.");

		{
			int heal = 300;
			if (info) return info_heal(0, 0, heal);
			if (cast) (void)cure_critical_wounds(heal);
		}
		break;

	case 15:
		if (name) return _("E̖", "Glyph of Warding");
		if (desc) return _("̂鏰̏ɁAX^[ʂ蔲菢ꂽ肷邱ƂłȂȂ郋[`B",
			"Sets a glyph on the floor beneath you. Monsters cannot attack you if you are on a glyph, but can try to break glyph.");

		{
			if (cast)
			{
				warding_glyph();
			}
		}
		break;

	case 16:
		if (name) return _("**", "Dispel Curse");
		if (desc) return _("ACeɂ͂Ȏ􂢂B", "Removes normal and heavy curse from equipped items.");

		{
			if (cast)
			{
				if (remove_all_curse())
				{
					msg_print(_("NɌĂ悤ȋCB", "You feel as if someone is watching over you."));
				}
			}
		}
		break;

	case 17:
		if (name) return _("ӎ", "Perception");
		if (desc) return _("ACeʂB", "Identifies an item.");

		{
			if (cast)
			{
				if (!ident_spell(FALSE)) return NULL;
			}
		}
		break;

	case 18:
		if (name) return _("AfbhގU", "Dispel Undead");
		if (desc) return _("ȆSẴAfbhɃ_[W^B", "Damages all undead monsters in sight.");

		{
			int dice = 1;
			int sides = plev * 5;

			if (info) return info_damage(dice, sides, 0);

			if (cast)
			{
				dispel_undead(damroll(dice, sides));
			}
		}
		break;

	case 19:
		if (name) return _("̍", "Day of the Dove");
		if (desc) return _("ȆSẴX^[𖣗BRƖB", "Attempts to charm all monsters in sight.");

		{
			int power = plev * 2;

			if (info) return info_power(power);

			if (cast)
			{
				charm_monsters(power);
			}
		}
		break;

	case 20:
		if (name) return _("v", "Cause Critical Wounds");
		if (desc) return _("1̂̃X^[ɑ_[W^BRƖB", "Wounds a monster critically unless resisted.");

		{
			int dice = 5 + (plev - 5) / 3;
			int sides = 15;

			if (info) return info_damage(dice, sides, 0);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;
				fire_ball_hide(GF_WOUNDS, dir, damroll(dice, sides), 0);
			}
		}
		break;

	case 21:
		if (name) return _("A҂̏", "Word of Recall");
		if (desc) return _("nɂƂ̓_W̍Ő[KցA_WɂƂ͒nւƈړB", "Recalls player from dungeon to town, or from town to the deepest level of dungeon.");

		{
			int base = 15;
			int sides = 20;

			if (info) return info_delay(base, sides);

			if (cast)
			{
				if (!word_of_recall()) return NULL;
			}
		}
		break;

	case 22:
		if (name) return _("^̍Ւd", "Alter Reality");
		if (desc) return _("݂̊Kč\B", "Recreates current dungeon level.");

		{
			int base = 15;
			int sides = 20;

			if (info) return info_delay(base, sides);

			if (cast)
			{
				alter_reality();
			}
		}
		break;

	case 23:
		if (name) return _("^EE", "Warding True");
		if (desc) return _("̂鏰Ǝ8}X̏̏ɁAX^[ʂ蔲菢ꂽ肷邱ƂłȂȂ郋[`B", "Creates glyphs in all adjacent squares and under you.");

		{
			int rad = 1;

			if (info) return info_radius(rad);

			if (cast)
			{
				warding_glyph();
				glyph_creation();
			}
		}
		break;

	case 24:
		if (name) return _("sщ", "Sterilization");
		if (desc) return _("̊K̑B郂X^[BłȂȂB", "Prevents any breeders on current level from breeding.");

		{
			if (cast)
			{
				num_repro += MAX_REPRO;
			}
		}
		break;

	case 25:
		if (name) return _("Sm", "Detection");
		if (desc) return _("߂̑SẴX^[A㩁AAKiAAăACemB", "Detects all monsters, traps, doors, stairs, treasures and items in your vicinity.");

		{
			int rad = DETECT_RAD_DEFAULT;

			if (info) return info_radius(rad);

			if (cast)
			{
				detect_all(rad);
			}
		}
		break;

	case 26:
		if (name) return _("Afbh", "Annihilate Undead");
		if (desc) return _("̎͂ɂAfbh݂̊KBRƖB",
			"Eliminates all nearby undead monsters, exhausting you.  Powerful or unique monsters may be able to resist.");

		{
			int power = plev + 50;

			if (info) return info_power(power);

			if (cast)
			{
				mass_genocide_undead(power, TRUE);
			}
		}
		break;

	case 27:
		if (name) return _("痢", "Clairvoyance");
		if (desc) return _("̊KŜivɏƂ炵A_WׂẴACemB", "Maps and lights whole dungeon level. Knows all objects location. And gives telepathy for a while.");

		{
			if (cast)
			{
				wiz_lite(FALSE);
			}
		}
		break;

	case 28:
		if (name) return _("S", "Restoration");
		if (desc) return _("ׂẴXe[^Xƌol񕜂B", "Restores all stats and experience.");

		{
			if (cast)
			{
				(void)restore_all_status();
				restore_level();
			}
		}
		break;

	case 29:
		if (name) return _("*̗͉*", "Healing True");
		if (desc) return _("ŋ̖̎@ŁAƞNOԂSB", "The greatest healing magic. Heals all HP, cut and stun.");

		{
			int heal = 2000;
			if (info) return info_heal(0, 0, heal);
			if (cast) (void)cure_critical_wounds(heal);
		}
		break;

	case 30:
		if (name) return _("ȂrW", "Holy Vision");
		if (desc) return _("ACe̎\͂SɒmB", "*Identifies* an item.");

		{
			if (cast)
			{
				if (!identify_fully(FALSE)) return NULL;
			}
		}
		break;

	case 31:
		if (name) return _("ɂ̑ϐ", "Ultimate Resistance");
		if (desc) return _("莞ԁAϐtAACƖ@h\͂㏸B", "Gives ultimate resistance, bonus to AC and speed.");

		{
			TIME_EFFECT base = (TIME_EFFECT)plev / 2;

			if (info) return info_duration(base, base);

			if (cast)
			{
				TIME_EFFECT v = randint1(base) + base;
				set_fast(v, FALSE);
				set_oppose_acid(v, FALSE);
				set_oppose_elec(v, FALSE);
				set_oppose_fire(v, FALSE);
				set_oppose_cold(v, FALSE);
				set_oppose_pois(v, FALSE);
				set_ultimate_res(v, FALSE);
			}
		}
		break;
	}

	return "";
}
